# This file was auto-generated by Fern from our API Definition.

import typing
import urllib.parse
from json.decoder import JSONDecodeError

import httpx
import pydantic

from ...core.api_error import ApiError


class HealthcheckClient:
    def __init__(self, *, environment: str):
        self._environment = environment

    def healthcheck(self) -> typing.Any:
        _response = httpx.request("GET", urllib.parse.urljoin(f"{self._environment}/", "ping"), timeout=60)
        if 200 <= _response.status_code < 300:
            return pydantic.parse_obj_as(typing.Any, _response.json())  # type: ignore
        try:
            _response_json = _response.json()
        except JSONDecodeError:
            raise ApiError(status_code=_response.status_code, body=_response.text)
        raise ApiError(status_code=_response.status_code, body=_response_json)


class AsyncHealthcheckClient:
    def __init__(self, *, environment: str):
        self._environment = environment

    async def healthcheck(self) -> typing.Any:
        async with httpx.AsyncClient() as _client:
            _response = await _client.request("GET", urllib.parse.urljoin(f"{self._environment}/", "ping"), timeout=60)
        if 200 <= _response.status_code < 300:
            return pydantic.parse_obj_as(typing.Any, _response.json())  # type: ignore
        try:
            _response_json = _response.json()
        except JSONDecodeError:
            raise ApiError(status_code=_response.status_code, body=_response.text)
        raise ApiError(status_code=_response.status_code, body=_response_json)
